From 0926f644ee592d0d65065991fe8263c1b657cc8d Mon Sep 17 00:00:00 2001
From: Adrian Taylor <adetaylor@chromium.org>
Date: Aug 25 2020 20:08:06 +0000
Subject: [PATCH 685/2232] Allow configurable options during C++ codegen.


This commit allows a higher-level code generator to pass options
into the cxx code generator.

---

diff --git a/gen/lib/src/lib.rs b/gen/lib/src/lib.rs
index de76d80..cecf654 100644
--- a/gen/lib/src/lib.rs
+++ b/gen/lib/src/lib.rs
@@ -5,15 +5,15 @@
 mod gen;
 mod syntax;
 
-use crate::gen::Opt;
+pub use crate::gen::Opt;
 use proc_macro2::TokenStream;
 
 pub use crate::gen::{Error, GeneratedCode, Result};
 
 /// Generate C++ bindings code from a Rust token stream. This should be a Rust
 /// token stream which somewhere contains a `#[cxx::bridge] mod {}`.
-pub fn generate_header_and_cc(rust_source: TokenStream) -> Result<GeneratedCode> {
-    gen::do_generate_from_tokens(rust_source, Opt::default())
+pub fn generate_header_and_cc(rust_source: TokenStream, opt: Opt) -> Result<GeneratedCode> {
+    gen::do_generate_from_tokens(rust_source, opt)
 }
 
 #[cfg(test)]
diff --git a/gen/src/mod.rs b/gen/src/mod.rs
index 3139ed3..f2e5c9b 100644
--- a/gen/src/mod.rs
+++ b/gen/src/mod.rs
@@ -26,8 +26,9 @@ struct Input {
     module: Vec<Item>,
 }
 
+/// Options for C++ code generation.
 #[derive(Default, Clone)]
-pub(super) struct Opt {
+pub struct Opt {
     /// Any additional headers to #include
     pub include: Vec<String>,
     /// Whether to set __attribute__((visibility("default")))

